// based on examples by Casey Reas and Hernando Barragan

import processing.serial.*; // használjuk a beépített soros könyvtárat

float boxX; // gombunk vízszintes pozíciója
float boxY; // gombunk függőleges pozíciója
int boxSize = 20; // gomb mérete
boolean mouseOverBox = false; // „ha az egér a gomb felett van” bináris változó, 
// alapállapota hamis

Serial port; // nevezzük soros portunkat portnak

void setup() {
  size(200, 200);
  boxX = width/2.0; //width és height beépített változók, az aktuális 
  // képernyőméret kiterjedéseit tartalmazzák
  boxY = height/2.0;
  rectMode(RADIUS); // a négyszöget a középpontjával fogjuk pozícionálni

  // listázzuk az összes elérhető soros portot 
  println(Serial.list()); 
  // nyissuk meg a portot, ahogy az előző példában
  port = new Serial(this, Serial.list()[0], 9600);
}

void draw() { 
  background(0);

  // megvizsgáljuk, hogy az egérkurzor a gomb felett van-e
  if (mouseX > boxX-boxSize && mouseX < boxX+boxSize && 
    mouseY > boxY-boxSize && mouseY < boxY+boxSize) {
    mouseOverBox = true;  
    // ha felette van, legyen a négyzet körvonala fehér
    stroke(255); 
    fill(153);
    // küldjünk a soros porton egy nagy H betűt
    port.write('H');
  } else {
    // máskülönben legyen a négyzet körvonala szürke
    stroke(153);
    fill(153);
    // és küldjünk L betűket, hogy a LED kikapcsolva legyen 
    port.write('L');      
    mouseOverBox = false;
  }

  // itt rajzoljuk a négyzetet
  rect(boxX, boxY, boxSize, boxSize);
}

